Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/LIM_SRC_2/limhdf_2.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/LIM_SRC_2/limhdf_2.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/LIM_SRC_2/limhdf_2.F90	(revision 7525)
@@ -125,5 +125,5 @@
          IF( iter == 1 ) THEN
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
-             DO jj= 2, jpjm1                                       ! diffusive trend : divergence of the fluxes
+             DO jj= 2, jpjm1
                 DO ji = fs_2 , fs_jpim1   ! vector opt. 
                    zdiv0(ji,jj) = zdiv(ji,jj)              ! save the 1st evaluation of the diffusive trend in zdiv0
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 7525)
@@ -132,8 +132,9 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-      zqnsoce(ji,jj) = qns(ji,jj)
+            zqnsoce(ji,jj) = qns(ji,jj)
          END DO
       END DO
 !$OMP END DO NOWAIT
+
 !$OMP DO schedule(static) private(jj,ji,zinda,ifvt,i1mfr,idfr,iflt,ial,iadv,ifral,ifrdv,zqsr,zqns,zqhc,zemp,zemp_snw,zfmm,zfsalt,zcd) 
       DO jj = 1, jpj
@@ -437,5 +438,5 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  utau_oce(ji,jj) = utau(ji,jj)                 !* save the air-ocean stresses at ice time-step
+                  utau_oce(ji,jj) = utau(ji,jj)       !* save the air-ocean stresses at ice time-step
                   vtau_oce(ji,jj) = vtau(ji,jj)
                END DO
@@ -497,5 +498,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            soce_0(ji,jj) = soce                     ! constant SSS and ice salinity used in levitating sea-ice case
+            soce_0(ji,jj) = soce             ! constant SSS and ice salinity used in levitating sea-ice case
             sice_0(ji,jj) = sice
          END DO
@@ -520,21 +521,21 @@
       ELSE
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-         snwice_mass  (ji,jj) = 0.e0           ! no mass exchanges
-         snwice_mass_b(ji,jj) = 0.e0           ! no mass exchanges
-         snwice_fmass (ji,jj) = 0.e0           ! no mass exchanges
-         END DO
-      END DO
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               snwice_mass  (ji,jj) = 0.e0           ! no mass exchanges
+               snwice_mass_b(ji,jj) = 0.e0           ! no mass exchanges
+               snwice_fmass (ji,jj) = 0.e0           ! no mass exchanges
+            END DO
+         END DO
       ENDIF
       IF( nn_ice_embd == 2 .AND.          &  ! full embedment (case 2) & no restart : 
          &   .NOT.ln_rstart ) THEN           ! deplete the initial ssh below sea-ice area
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-         sshn(ji,jj) = sshn(ji,jj) - snwice_mass(ji,jj) * r1_rau0
-         sshb(ji,jj) = sshb(ji,jj) - snwice_mass(ji,jj) * r1_rau0
-         END DO
-      END DO
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               sshn(ji,jj) = sshn(ji,jj) - snwice_mass(ji,jj) * r1_rau0
+               sshb(ji,jj) = sshb(ji,jj) - snwice_mass(ji,jj) * r1_rau0
+            END DO
+         END DO
 !!gm I really don't like this staff here...  Find a way to put that elsewhere or differently
 !!gm
@@ -542,9 +543,13 @@
 
 !$OMP PARALLEL
-!$OMP DO schedule(static) private(jk)
-            do jk = 1,jpkm1                     ! adjust initial vertical scale factors
-               e3t_n(:,:,jk) = e3t_0(:,:,jk)*( 1._wp + sshn(:,:)*tmask(:,:,1)/(ht_0(:,:) + 1.0 - tmask(:,:,1)) )
-               e3t_b(:,:,jk) = e3t_0(:,:,jk)*( 1._wp + sshb(:,:)*tmask(:,:,1)/(ht_0(:,:) + 1.0 - tmask(:,:,1)) )
-            end do
+!$OMP DO schedule(static) private(jk, jj, ji)
+            DO jk = 1,jpkm1                     ! adjust initial vertical scale factors
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     e3t_n(ji,jj,jk) = e3t_0(ji,jj,jk)*( 1._wp + sshn(ji,jj)*tmask(ji,jj,1)/(ht_0(ji,jj) + 1.0 - tmask(ji,jj,1)) )
+                     e3t_b(ji,jj,jk) = e3t_0(ji,jj,jk)*( 1._wp + sshb(ji,jj)*tmask(ji,jj,1)/(ht_0(ji,jj) + 1.0 - tmask(ji,jj,1)) )
+                  END DO
+               END DO
+            END DO
 !$OMP DO schedule(static) private(jk, jj, ji)
             DO jk = 1, jpk
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/LIM_SRC_2/limthd_2.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/LIM_SRC_2/limthd_2.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/LIM_SRC_2/limthd_2.F90	(revision 7525)
@@ -446,5 +446,4 @@
             fr_i  (ji,jj) = 1.0 - frld(ji,jj)  
             hicifp(ji,jj) = hicif(ji,jj) * fr_i(ji,jj) - hicifp(ji,jj)
-            ztmp(ji,jj) = 1. - pfrld(ji,jj)                              ! fraction of ice after the dynamic, before the thermodynamic
          END DO
       END DO
@@ -452,4 +451,10 @@
       ! Outputs
       !--------------------------------------------------------------------------------
+!$OMP PARALLEL DO schedule(static) private(jj,ji)
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            ztmp(ji,jj) = 1. - pfrld(ji,jj)                              ! fraction of ice after the dynamic, before the thermodynamic
+         END DO
+      END DO
       IF( iom_use('ist_cea'    ) )   CALL iom_put( 'ist_cea', (sist(:,:) - rt0) * ztmp(:,:) )   ! Ice surface temperature   [Celius]
       IF( iom_use('qsr_ai_cea' ) )   CALL iom_put( 'qsr_ai_cea', qsr_ice(:,:,1) * ztmp(:,:) )   ! Solar flux over the ice     [W/m2]
@@ -469,5 +474,10 @@
       IF( iom_use('bicemel_cea') )   CALL iom_put( 'bicemel_cea' , zdvomif(:,:) * zztmp     )   ! Melt at Sea Ice bottom   [kg/m2/s]
       IF( iom_use('licepro_cea') ) THEN
-         zlicegr(:,:) = MAX( 0.e0, rdm_ice(:,:)-zlicegr(:,:) )
+!$OMP PARALLEL DO schedule(static) private(jj,ji)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zlicegr(ji,jj) = MAX( 0.e0, rdm_ice(ji,jj)-zlicegr(ji,jj) )
+            END DO
+         END DO
                                      CALL iom_put( 'licepro_cea' , zlicegr(:,:) * zztmp     )   ! Lateral sea ice growth   [kg/m2/s]
       ENDIF
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DIA/diafwb.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DIA/diafwb.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DIA/diafwb.F90	(revision 7525)
@@ -55,6 +55,7 @@
       REAL(wp) :: zarea, zvol, zwei
       REAL(wp) :: ztemi(4), ztemo(4), zsali(4), zsalo(4), zflxi(4), zflxo(4)
-      REAL(wp) :: zt, zs, zu  
+      REAL(wp) :: zt, zs, zu
       REAL(wp) :: zsm0, zfwfnew
+      REAL(wp), DIMENSION(:,:)     ::   ztmp      ! 2D workspace
       IF( cp_cfg == "orca" .AND. jp_cfg == 1 .OR. jp_cfg == 2 .OR. jp_cfg == 4 ) THEN
       !!----------------------------------------------------------------------
@@ -63,5 +64,4 @@
       ! Mean global salinity
       zsm0 = 34.72654
-
       ! To compute fwf mean value mean fwf
 
@@ -72,5 +72,11 @@
          a_salb   = 0.e0 ! valeur de sal au debut de la simulation
          ! sshb used because diafwb called after tranxt (i.e. after the swap)
-         a_sshb = SUM( e1e2t(:,:) * sshb(:,:) * tmask_i(:,:) )
+!$OMP PARALLEL DO schedule(static) private(jj,ji) REDUCTION(+:a_sshb)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               ztmp(ji,jj) = e1e2t(ji,jj) * sshb(ji,jj) * tmask_i(ji,jj)
+               a_sshb = a_sshb + ztmp(ji,jj)
+            END DO
+         END DO
          IF( lk_mpp )   CALL mpp_sum( a_sshb )      ! sum over the global domain
 
@@ -86,6 +92,13 @@
          IF( lk_mpp )   CALL mpp_sum( a_salb )      ! sum over the global domain
       ENDIF
-      
-      a_fwf    = SUM( e1e2t(:,:) * ( emp(:,:)-rnf(:,:) ) * tmask_i(:,:) ) 
+        
+!$OMP PARALLEL DO schedule(static) private(jj,ji) REDUCTION(+:a_fwf)
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            ztmp(ji,jj) = e1e2t(ji,jj) * ( emp(ji,jj)-rnf(ji,jj) ) * tmask_i(ji,jj)
+            a_fwf = a_fwf + ztmp(ji,jj)
+         END DO
+      END DO
+
       IF( lk_mpp )   CALL mpp_sum( a_fwf    )       ! sum over the global domain
 
@@ -97,7 +110,19 @@
          zfwfnew = 0.e0
          ! Mean sea level at nitend
-         a_sshn = SUM( e1e2t(:,:) * sshn(:,:) * tmask_i(:,:) )
+!$OMP PARALLEL DO schedule(static) private(jj,ji) REDUCTION(+:a_sshn)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               ztmp(ji,jj) = e1e2t(ji,jj) * sshn(ji,jj) * tmask_i(ji,jj)
+               a_sshn = a_sshn + ztmp(ji,jj)
+            END DO
+         END DO
          IF( lk_mpp )   CALL mpp_sum( a_sshn )      ! sum over the global domain
-         zarea  = SUM( e1e2t(:,:) *             tmask_i(:,:) )
+!$OMP PARALLEL DO schedule(static) private(jj,ji) REDUCTION(+:zarea)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               ztmp(ji,jj) = e1e2t(ji,jj) *            tmask_i(ji,jj)
+               zarea = zarea + ztmp(ji,jj)
+            END DO
+         END DO
          IF( lk_mpp )   CALL mpp_sum( zarea  )      ! sum over the global domain
          
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 7525)
@@ -241,7 +241,11 @@
             END DO
          END DO
-!$OMP DO schedule(static) private(jk)
+!$OMP DO schedule(static) private(jk,jj,ji)
          DO jk = 1, jpk
-            z3d(:,:,jk) = wn(:,:,jk) * z2d(:,:) 
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  z3d(ji,jj,jk) = wn(ji,jj,jk) * z2d(ji,jj) 
+               END DO
+            END DO
          END DO
 !$OMP END DO NOWAIT
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DOM/domngb.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DOM/domngb.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DOM/domngb.F90	(revision 7525)
@@ -63,39 +63,39 @@
       CASE( 'U' )
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            zglam(ji,jj) = glamu(ji,jj) ; zgphi(ji,jj) = gphiu(ji,jj)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zglam(ji,jj) = glamu(ji,jj) ; zgphi(ji,jj) = gphiu(ji,jj)
+            END DO
          END DO
-      END DO
-      zmask(nldi:nlei,nldj:nlej) = umask(nldi:nlei,nldj:nlej,ik)
+         zmask(nldi:nlei,nldj:nlej) = umask(nldi:nlei,nldj:nlej,ik)
       CASE( 'V' )  
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            zglam(ji,jj) = glamv(ji,jj) ; zgphi(ji,jj) = gphiv(ji,jj)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zglam(ji,jj) = glamv(ji,jj) ; zgphi(ji,jj) = gphiv(ji,jj)
+            END DO
          END DO
-      END DO
-      zmask(nldi:nlei,nldj:nlej) = vmask(nldi:nlei,nldj:nlej,ik)
+         zmask(nldi:nlei,nldj:nlej) = vmask(nldi:nlei,nldj:nlej,ik)
       CASE( 'F' )  
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            zglam(ji,jj) = glamf(ji,jj) ; zgphi(ji,jj) = gphif(ji,jj)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zglam(ji,jj) = glamf(ji,jj) ; zgphi(ji,jj) = gphif(ji,jj)
+            END DO
          END DO
-      END DO
-      zmask(nldi:nlei,nldj:nlej) = fmask(nldi:nlei,nldj:nlej,ik)
+         zmask(nldi:nlei,nldj:nlej) = fmask(nldi:nlei,nldj:nlej,ik)
       CASE DEFAULT 
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            zglam(ji,jj) = glamt(ji,jj) ; zgphi(ji,jj) = gphit(ji,jj)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zglam(ji,jj) = glamt(ji,jj) ; zgphi(ji,jj) = gphit(ji,jj)
+            END DO
          END DO
-      END DO
-      zmask(nldi:nlei,nldj:nlej) = tmask(nldi:nlei,nldj:nlej,ik)
+         zmask(nldi:nlei,nldj:nlej) = tmask(nldi:nlei,nldj:nlej,ik)
       END SELECT
 
       IF (jphgr_msh /= 2 .AND. jphgr_msh /= 3) THEN
          zlon       = MOD( plon       + 720., 360. )                                     ! plon between    0 and 360
-!$OMP PARALLEL DO schedule(static) private(jj, ji, zglam, zlon)
+!$OMP PARALLEL DO schedule(static) private(jj, ji, zlon)
          DO jj = 1, jpj
             DO ji = 1, jpi
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 7525)
@@ -132,8 +132,12 @@
             END DO
          END DO
-!$OMP DO schedule(static) private(jk)
+!$OMP DO schedule(static) private(jk,jj,ji)
          DO jk = 1, jpkm1
-            ua(:,:,jk) = ( ua(:,:,jk) - zue(:,:) * r1_hu_a(:,:) + ua_b(:,:) ) * umask(:,:,jk)
-            va(:,:,jk) = ( va(:,:,jk) - zve(:,:) * r1_hv_a(:,:) + va_b(:,:) ) * vmask(:,:,jk)
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ua(ji,jj,jk) = ( ua(ji,jj,jk) - zue(ji,jj) * r1_hu_a(ji,jj) + ua_b(ji,jj) ) * umask(ji,jj,jk)
+                  va(ji,jj,jk) = ( va(ji,jj,jk) - zve(ji,jj) * r1_hv_a(ji,jj) + va_b(ji,jj) ) * vmask(ji,jj,jk)
+               END DO
+            END DO
          END DO
 !$OMP END DO NOWAIT
@@ -145,8 +149,12 @@
             ! In the forward case, this is done below after asselin filtering   
             ! so that asselin contribution is removed at the same time 
-!$OMP PARALLEL DO schedule(static) private(jk)
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
             DO jk = 1, jpkm1
-               un(:,:,jk) = ( un(:,:,jk) - un_adv(:,:) + un_b(:,:) )*umask(:,:,jk)
-               vn(:,:,jk) = ( vn(:,:,jk) - vn_adv(:,:) + vn_b(:,:) )*vmask(:,:,jk)
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     un(ji,jj,jk) = ( un(ji,jj,jk) - un_adv(ji,jj) + un_b(ji,jj) )*umask(ji,jj,jk)
+                     vn(ji,jj,jk) = ( vn(ji,jj,jk) - vn_adv(ji,jj) + vn_b(ji,jj) )*vmask(ji,jj,jk)
+                  END DO
+               END DO
             END DO  
          ENDIF
@@ -198,8 +206,8 @@
                   zua(ji,jj,jk) = un(ji,jj,jk)             ! save the now velocity before the asselin filter
                   zva(ji,jj,jk) = vn(ji,jj,jk)             ! (caution: there will be a shift by 1 timestep in the
-               END DO
-            END DO
-         END DO
-         !                                  !  computation of the asselin filter trends)
+                                                           !  computation of the asselin filter trends)
+               END DO
+            END DO
+         END DO
       ENDIF
 
@@ -208,16 +216,24 @@
       IF( neuler == 0 .AND. kt == nit000 ) THEN        !* Euler at first time-step: only swap
 !$OMP PARALLEL
-!$OMP DO schedule(static) private(jk)
+!$OMP DO schedule(static) private(jk,jj,ji)
          DO jk = 1, jpkm1
-            un(:,:,jk) = ua(:,:,jk)                          ! un <-- ua
-            vn(:,:,jk) = va(:,:,jk)
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  un(ji,jj,jk) = ua(ji,jj,jk)                          ! un <-- ua
+                  vn(ji,jj,jk) = va(ji,jj,jk)
+               END DO
+            END DO
          END DO
 !$OMP END DO NOWAIT
          IF(.NOT.ln_linssh ) THEN
-!$OMP DO schedule(static) private(jk)
+!$OMP DO schedule(static) private(jk,jj,ji)
             DO jk = 1, jpkm1
-               e3t_b(:,:,jk) = e3t_n(:,:,jk)
-               e3u_b(:,:,jk) = e3u_n(:,:,jk)
-               e3v_b(:,:,jk) = e3v_n(:,:,jk)
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     e3t_b(ji,jj,jk) = e3t_n(ji,jj,jk)
+                     e3u_b(ji,jj,jk) = e3u_n(ji,jj,jk)
+                     e3v_b(ji,jj,jk) = e3v_n(ji,jj,jk)
+                  END DO
+               END DO
             END DO
 !$OMP END DO NOWAIT
@@ -256,7 +272,11 @@
                END DO
             ELSE
-!$OMP PARALLEL DO schedule(static) private(jk)
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
                DO jk = 1, jpkm1
-                  e3t_b(:,:,jk) = e3t_n(:,:,jk) + atfp * ( e3t_b(:,:,jk) - 2._wp * e3t_n(:,:,jk) + e3t_a(:,:,jk) )
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi    
+                        e3t_b(ji,jj,jk) = e3t_n(ji,jj,jk) + atfp * ( e3t_b(ji,jj,jk) - 2._wp * e3t_n(ji,jj,jk) + e3t_a(ji,jj,jk) )
+                     END DO
+                  END DO
                END DO
                ! Add volume filter correction: compatibility with tracer advection scheme
@@ -365,8 +385,12 @@
                END DO
             END DO
-!$OMP DO schedule(static) private(jk)
+!$OMP DO schedule(static) private(jk,jj,ji)
             DO jk = 1, jpkm1
-               ub(:,:,jk) = ub(:,:,jk) - (zue(:,:) * r1_hu_n(:,:) - un_b(:,:)) * umask(:,:,jk)
-               vb(:,:,jk) = vb(:,:,jk) - (zve(:,:) * r1_hv_n(:,:) - vn_b(:,:)) * vmask(:,:,jk)
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     ub(ji,jj,jk) = ub(ji,jj,jk) - (zue(ji,jj) * r1_hu_n(ji,jj) - un_b(ji,jj)) * umask(ji,jj,jk)
+                     vb(ji,jj,jk) = vb(ji,jj,jk) - (zve(ji,jj) * r1_hv_n(ji,jj) - vn_b(ji,jj)) * vmask(ji,jj,jk)
+                  END DO
+               END DO
             END DO
 !$OMP END DO NOWAIT
@@ -446,5 +470,5 @@
       ENDIF
       IF( l_trddyn ) THEN                ! 3D output: asselin filter trends on momentum
-!$OMP DO schedule(static) private(jk, jj, ji)
+!$OMP PARALLEL DO schedule(static) private(jk, jj, ji)
          DO jk = 1, jpkm1
             DO jj = 1, jpj
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 7525)
@@ -1314,8 +1314,12 @@
       ! Update barotropic trend:
       IF( ln_dynadv_vec .OR. ln_linssh ) THEN
-!$OMP PARALLEL DO schedule(static) private(jk)
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
          DO jk=1,jpkm1
-            ua(:,:,jk) = ua(:,:,jk) + ( ua_b(:,:) - ub_b(:,:) ) * z1_2dt_b
-            va(:,:,jk) = va(:,:,jk) + ( va_b(:,:) - vb_b(:,:) ) * z1_2dt_b
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ua(ji,jj,jk) = ua(ji,jj,jk) + ( ua_b(ji,jj) - ub_b(ji,jj) ) * z1_2dt_b
+                  va(ji,jj,jk) = va(ji,jj,jk) + ( va_b(ji,jj) - vb_b(ji,jj) ) * z1_2dt_b
+               END DO
+            END DO
          END DO
       ELSE
@@ -1335,8 +1339,12 @@
          !
 !$OMP PARALLEL
-!$OMP DO schedule(static) private(jk)
+!$OMP DO schedule(static) private(jk,jj,ji)
          DO jk=1,jpkm1
-            ua(:,:,jk) = ua(:,:,jk) + r1_hu_n(:,:) * ( ua_b(:,:) - ub_b(:,:) * hu_b(:,:) ) * z1_2dt_b
-            va(:,:,jk) = va(:,:,jk) + r1_hv_n(:,:) * ( va_b(:,:) - vb_b(:,:) * hv_b(:,:) ) * z1_2dt_b
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ua(ji,jj,jk) = ua(ji,jj,jk) + r1_hu_n(ji,jj) * ( ua_b(ji,jj) - ub_b(ji,jj) * hu_b(ji,jj) ) * z1_2dt_b
+                  va(ji,jj,jk) = va(ji,jj,jk) + r1_hv_n(ji,jj) * ( va_b(ji,jj) - vb_b(ji,jj) * hv_b(ji,jj) ) * z1_2dt_b
+               END DO
+            END DO
          END DO
 !$OMP END DO NOWAIT
@@ -1352,10 +1360,14 @@
       ENDIF
       !
-!$OMP PARALLEL DO schedule(static) private(jk)
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
       DO jk = 1, jpkm1
-         ! Correct velocities:
-         un(:,:,jk) = ( un(:,:,jk) + un_adv(:,:) - un_b(:,:) ) * umask(:,:,jk)
-         vn(:,:,jk) = ( vn(:,:,jk) + vn_adv(:,:) - vn_b(:,:) ) * vmask(:,:,jk)
-         !
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               ! Correct velocities:
+               un(ji,jj,jk) = ( un(ji,jj,jk) + un_adv(ji,jj) - un_b(ji,jj) ) * umask(ji,jj,jk)
+               vn(ji,jj,jk) = ( vn(ji,jj,jk) + vn_adv(ji,jj) - vn_b(ji,jj) ) * vmask(ji,jj,jk)
+               !
+            END DO
+         END DO
       END DO
       !
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 7525)
@@ -105,9 +105,9 @@
       DO jk = 1, jpkm1                                 ! Horizontal divergence of barotropic transports
 !$OMP DO schedule(static) private(jj, ji)
-            DO jj = 1, jpj
-               DO ji = 1, jpi   ! vector opt.
-                  zhdiv(ji,jj) = zhdiv(ji,jj) + e3t_n(ji,jj,jk) * hdivn(ji,jj,jk)
-               END DO
-            END DO           
+         DO jj = 1, jpj
+            DO ji = 1, jpi   ! vector opt.
+               zhdiv(ji,jj) = zhdiv(ji,jj) + e3t_n(ji,jj,jk) * hdivn(ji,jj,jk)
+            END DO
+         END DO           
       END DO
 !$OMP END PARALLEL
@@ -120,9 +120,9 @@
       IF(ln_wd) CALL wad_lmt(sshb, zcoef * (emp_b(:,:) + emp(:,:)), z2dt)
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            ssha(ji,jj) = (  sshb(ji,jj) - z2dt * ( zcoef * ( emp_b(ji,jj) + emp(ji,jj) ) + zhdiv(ji,jj) )  ) * ssmask(ji,jj)
-         END DO
-      END DO           
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               ssha(ji,jj) = (  sshb(ji,jj) - z2dt * ( zcoef * ( emp_b(ji,jj) + emp(ji,jj) ) + zhdiv(ji,jj) )  ) * ssmask(ji,jj)
+            END DO
+         END DO           
       IF ( .NOT.ln_dynspg_ts ) THEN
          ! These lines are not necessary with time splitting since
@@ -143,9 +143,9 @@
          CALL ssh_asm_inc( kt )
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            ssha(ji,jj) = ssha(ji,jj) + z2dt * ssh_iau(ji,jj)
-         END DO
-      END DO           
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               ssha(ji,jj) = ssha(ji,jj) + z2dt * ssh_iau(ji,jj)
+            END DO
+         END DO           
       ENDIF
 #endif
@@ -193,5 +193,10 @@
          IF(lwp) WRITE(numout,*) '~~~~~ '
          !
-         wn(ji,jj,jpk) = 0._wp                  ! bottom boundary condition: w=0 (set once for all)
+!$OMP PARALLEL DO schedule(static) private(jj, ji)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               wn(ji,jj,jpk) = 0._wp                  ! bottom boundary condition: w=0 (set once for all)
+            END DO
+         END DO 
       ENDIF
       !                                           !------------------------------!
@@ -221,6 +226,6 @@
             DO jj = 1, jpj
                DO ji = 1, jpi   ! vector opt.
-            wn(ji,jj,jk) = wn(ji,jj,jk+1) - ( e3t_n(ji,jj,jk) * hdivn(ji,jj,jk) + zhdiv(ji,jj,jk)    &
-               &                         + z1_2dt * ( e3t_a(ji,jj,jk) - e3t_b(ji,jj,jk) )     ) * tmask(ji,jj,jk)
+                  wn(ji,jj,jk) = wn(ji,jj,jk+1) - ( e3t_n(ji,jj,jk) * hdivn(ji,jj,jk) + zhdiv(ji,jj,jk)    &
+                  &                         + z1_2dt * ( e3t_a(ji,jj,jk) - e3t_b(ji,jj,jk) )     ) * tmask(ji,jj,jk)
                END DO
             END DO
@@ -233,7 +238,7 @@
             DO jj = 1, jpj
                DO ji = 1, jpi   ! vector opt.
-            ! computation of w
-            wn(ji,jj,jk) = wn(ji,jj,jk+1) - (  e3t_n(ji,jj,jk) * hdivn(ji,jj,jk)                 &
-               &                         + z1_2dt * ( e3t_a(ji,jj,jk) - e3t_b(ji,jj,jk) )  ) * tmask(ji,jj,jk)
+                  ! computation of w
+                  wn(ji,jj,jk) = wn(ji,jj,jk+1) - (  e3t_n(ji,jj,jk) * hdivn(ji,jj,jk)                 &
+                  &                         + z1_2dt * ( e3t_a(ji,jj,jk) - e3t_b(ji,jj,jk) )  ) * tmask(ji,jj,jk)
                 END DO
             END DO
@@ -291,10 +296,10 @@
          & ( ln_bt_fw    .AND. ln_dynspg_ts )      ) THEN 
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            sshb(ji,jj) = sshn(ji,jj)                              ! before <-- now
-            sshn(ji,jj) = ssha(ji,jj)                              ! now    <-- after  (before already = now)
-         END DO
-      END DO           
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               sshb(ji,jj) = sshn(ji,jj)                              ! before <-- now
+               sshn(ji,jj) = ssha(ji,jj)                              ! now    <-- after  (before already = now)
+            END DO
+         END DO           
          !
       ELSE           !==  Leap-Frog time-stepping: Asselin filter + swap  ==!
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 7525)
@@ -160,13 +160,13 @@
             IF(lwp) WRITE(numout,*) '          momentum mixing coef. = constant '
 !$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
-      DO jk = 1, jpk
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               ahmt(ji,jj,jk) = zah0 * tmask(ji,jj,jk)
-               ahmf(ji,jj,jk) = zah0 * fmask(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-            !
+               DO jk = 1, jpk
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        ahmt(ji,jj,jk) = zah0 * tmask(ji,jj,jk)
+                        ahmf(ji,jj,jk) = zah0 * fmask(ji,jj,jk)
+                     END DO
+                  END DO
+               END DO
+               !
          CASE(  10  )      !==  fixed profile  ==!
             IF(lwp) WRITE(numout,*) '          momentum mixing coef. = F( depth )'
@@ -189,8 +189,12 @@
 !!              do we introduce a scaling by the max value of the array, and then multiply by zah0 ????
 !!              better:  check that the max is <=1  i.e. it is a shape from 0 to 1, not a coef that has physical dimension
-!$OMP PARALLEL DO schedule(static) private(jk)
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
             DO jk = 2, jpkm1
-               ahmt(:,:,jk) = ahmt(:,:,1) * tmask(:,:,jk)
-               ahmf(:,:,jk) = ahmf(:,:,1) * fmask(:,:,jk)
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     ahmt(ji,jj,jk) = ahmt(ji,jj,1) * tmask(ji,jj,jk)
+                     ahmf(ji,jj,jk) = ahmf(ji,jj,1) * fmask(ji,jj,jk)
+                  END DO
+               END DO
             END DO
             !
@@ -208,8 +212,12 @@
 !!gm Question : info for LAP or BLP case  to take into account the SQRT in the bilaplacian case ????
 !!              do we introduce a scaling by the max value of the array, and then multiply by zah0 ????
-!$OMP PARALLEL DO schedule(static) private(jk)
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
             DO jk = 1, jpkm1
-               ahmt(:,:,jk) = ahmt(:,:,jk) * tmask(:,:,jk)
-               ahmf(:,:,jk) = ahmf(:,:,jk) * fmask(:,:,jk)
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     ahmt(ji,jj,jk) = ahmt(ji,jj,jk) * tmask(ji,jj,jk)
+                     ahmf(ji,jj,jk) = ahmf(ji,jj,jk) * fmask(ji,jj,jk)
+                  END DO
+               END DO
             END DO
             !
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/SBC/geo2ocean.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/SBC/geo2ocean.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/SBC/geo2ocean.F90	(revision 7525)
@@ -158,5 +158,6 @@
       !
 !$OMP PARALLEL
-!$OMP DO schedule(static) private(jj,ji,zlam,zphi,zxnpt,zynpt,znnpt,zxnpu,zynpu,znnpu,zxnpv,zynpv,znnpv,zxnpf,zynpf,znnpf,zlan,zphh,zxvvt,zyvvt,znvvt,zxffu,zyffu,znffu,zxffv,zyffv,znffv,zxuuf,zyuuf,znuuf)
+!$OMP DO schedule(static) private(jj,ji,zlam,zphi,zxnpt,zynpt,znnpt,zxnpu,zynpu,znnpu,zxnpv,zynpv,znnpv,zxnpf) &
+!$OMP& private(zynpf,znnpf,zlan,zphh,zxvvt,zyvvt,znvvt,zxffu,zyffu,znffu,zxffv,zyffv,znffv,zxuuf,zyuuf,znuuf)
       DO jj = 2, jpjm1
          DO ji = fs_2, jpi   ! vector opt.
